#include "common.h"

#define ME(id) (id)
#define OTHER(id) (!id)

bool i_want_in[2] = { false, false };
int  whose_turn; /* set in plock, always before use */

void pinit(void) {}

/* Peterson's solution.
 *
 * Presumption: Only two threads.
 *
 * Switch at note 1 or 2:
 *  First to write whose_turn will win the lock
 *  Last to write whose_turn will wait
 *
 * Switch at note 3:
 *  If turn becomes mine other will wait until I do not want in anymore
 *  If other want in he'll set turn to mine and have to wait
 *
 * If I'm the only one that want in I'll get in
 * If I wait I'll continue when other get out
 */
void plock(int tid) {
	i_want_in[ME(tid)] = true;
	/* note 1 */
	whose_turn = OTHER(tid);
	/* note 2 */
	while ( i_want_in[OTHER(tid)] && /* note 3 */
		whose_turn == OTHER(tid) )
		; /* busy wait */
}

void punlock(int tid) {
	i_want_in[ME(tid)] = false;
}

