#include "wrap/thread.h"
#include "wrap/synch.h"
#include <stdlib.h>
#include <stdio.h>

int *buffer;
int size;
int sum = 0;
int suml = 0;
int sumh = 0;

struct semaphore part_done;

static void sum_low(void *p) {
	int i;
	UNUSED(p);
	for (i = 0; i < size / 2; ++i)
		suml += buffer[i];
	sema_up(&part_done);
}

static void sum_high(void *p) {
	int i;
	UNUSED(p);
	for (i = size / 2; i < size; ++i)
		sumh += buffer[i];
	sema_up(&part_done);
}

int main(int argc, char *argv[]) {
	int i;

	size = 2000000;
	if (argc >= 2)
		size = atoi(argv[1]);

	buffer = malloc(sizeof(*buffer)*size);
	for (i = 0; i < size; ++i)
		buffer[i] = 1;

	sema_init(&part_done, 0);

	thread_create("", 0, &sum_low, NULL);
	thread_create("", 0, &sum_high, NULL);

	sema_down(&part_done);
	sema_down(&part_done);

	sum = suml + sumh;

	printf("** The size is %d\n", size);
	printf("And the sum is %d\n", sum);

	return 0;
}
